#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#define int long long
using namespace std;

const long double ex = 1e-16;

long double fp(long double ch, int st)
{
    if(st == 0)
        return 1;

    if(st == 1)
        return ch;

    if(st % 2 == 0)
    {
        long double a = fp(ch, st / 2);
        if (a * a < ex)
            return 0;
        return a * a;
    }
    long double res = fp(ch, st - 1) * ch;
    if (res < ex)
        return 0;
    return fp(ch, st - 1) * ch;
}
main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<long double, long double>>v;
    long double r;
    cin >> r;
    long double d, k;

    for(int i = 0; i < n; i++)
    {
        cin >> d >> k;
        v.push_back({d, k});

    }

    for(int i = 0; i < m; i++)
    {
        cin >> d;
        v.push_back({d, 1e9 + 7});
    }

    sort(v.begin(), v.end());
    long double otv = 0;

    if(v[0].second == 1e9 + 7)
        cout << "0 ";

    else otv += r * v[0].second;

    for(int i = 1; i < v.size(); i++)
    {
        long double ch = fp((long double)1 - r, v[i].first - v[i - 1].first );
        otv *= ch;

        if(v[i].second == 1e9 + 7 )
        {
            cout << fixed << setprecision(900) << otv << " ";
        }

        else otv += v[i].second * r;
    }
}

/*
1 1
0.5
1 1000000000
100
*/
